searchNodes=[{"doc":"Post a query to Druid Broker or request its status.Use Panoramix.Query to build a query.ExamplesBuild a query like this:use Panoramix q = from &quot;my_datasource&quot;, query_type: &quot;timeseries&quot;, intervals: [&quot;2019-03-01T00:00:00+00:00/2019-03-04T00:00:00+00:00&quot;], granularity: :day, filter: dimensions.foo == &quot;bar&quot;, aggregations: [event_count: count(), unique_id_count: hyperUnique(:user_unique)]And then send it:Panoramix.post_query(q, :default)Where :default is a configuration profile pointing to your Druid server.The default value for the profile argument is :default, so if you only need a single configuration you can omit it:Panoramix.post_query(q)Response example:{:ok, [ %{ &quot;result&quot; =&gt; %{ &quot;event_count&quot; =&gt; 7544, &quot;unique_id_count&quot; =&gt; 43.18210933535 }, &quot;timestamp&quot; =&gt; &quot;2019-03-01T00:00:00.000Z&quot; }, %{ &quot;result&quot; =&gt; %{ &quot;event_count&quot; =&gt; 1051, &quot;unique_id_count&quot; =&gt; 104.02052398847 }, &quot;timestamp&quot; =&gt; &quot;2019-03-02T00:00:00.000Z&quot; }, %{ &quot;result&quot; =&gt; %{ &quot;event_count&quot; =&gt; 4591, &quot;unique_id_count&quot; =&gt; 79.19885795313 }, &quot;timestamp&quot; =&gt; &quot;2019-03-03T00:00:00.000Z&quot; } ]}To request status from Broker runPanoramix.status(:default)","ref":"Panoramix.html","title":"Panoramix","type":"module"},{"doc":"Format a date or a datetime into a format that Druid expects.Examplesiex&gt; Panoramix.format_time! ~D[2018-07-20] &quot;2018-07-20&quot; iex&gt; Panoramix.format_time!( ...&gt; Timex.to_datetime({{2018,07,20},{1,2,3}})) &quot;2018-07-20T01:02:03+00:00&quot;","ref":"Panoramix.html#format_time!/1","title":"Panoramix.format_time!/1","type":"function"},{"doc":"","ref":"Panoramix.html#post_query/2","title":"Panoramix.post_query/2","type":"function"},{"doc":"","ref":"Panoramix.html#post_query!/2","title":"Panoramix.post_query!/2","type":"function"},{"doc":"","ref":"Panoramix.html#status/1","title":"Panoramix.status/1","type":"function"},{"doc":"","ref":"Panoramix.html#status!/1","title":"Panoramix.status!/1","type":"function"},{"doc":"Provides functions for building Druid query requests.","ref":"Panoramix.Query.html","title":"Panoramix.Query","type":"module"},{"doc":"Use from macro to build Druid queries. See Druid documentation to learn about available fields and general query object structure.Example iex(1)&gt; use Panoramix Panoramix.Query iex(2)&gt; q = from &quot;my_datasource&quot;, ...(2)&gt; query_type: &quot;timeseries&quot;, ...(2)&gt; intervals: [&quot;2019-03-01T00:00:00+00:00/2019-03-04T00:00:00+00:00&quot;], ...(2)&gt; granularity: :day, ...(2)&gt; filter: dimensions.foo == &quot;bar&quot;, ...(2)&gt; aggregations: [event_count: count(), ...(2)&gt; unique_id_count: hyperUnique(:user_unique)] %Panoramix.Query{ aggregations: [ %{name: :event_count, type: &quot;count&quot;}, %{fieldName: :user_unique, name: :unique_id_count, type: :hyperUnique} ], analysis_types: nil, bound: nil, context: %{priority: 0, timeout: 120000}, data_source: &quot;my_datasource&quot;, dimension: nil, dimensions: nil, filter: %{dimension: &quot;foo&quot;, type: &quot;selector&quot;, value: &quot;bar&quot;}, granularity: :day, intervals: [&quot;2019-03-01T00:00:00+00:00/2019-03-04T00:00:00+00:00&quot;], limit: nil, limit_spec: nil, merge: nil, metric: nil, post_aggregations: nil, query: nil, query_type: &quot;timeseries&quot;, search_dimensions: nil, sort: nil, threshold: nil, to_include: nil, virtual_columns: nil }Some HLL aggregation names are capitalized and therefore won't play well with the macro. For such cases use their aliases as a workaround: hllSketchBuild, hllSketchMerge, hllSketchEstimate, hllSketchUnion, hllSketchToString.The aggregation aliases will be replaced with original names when building a query.Example iex(1)&gt; use Panoramix Panoramix.Query iex(2)&gt; query = from &quot;my_datasource&quot;, ...(2)&gt; query_type: &quot;timeseries&quot;, ...(2)&gt; intervals: [&quot;2018-05-29T00:00:00+00:00/2018-06-05T00:00:00+00:00&quot;], ...(2)&gt; granularity: :day, ...(2)&gt; aggregations: [event_count: count(), ...(2)&gt; unique_ids: hllSketchMerge(:user_unique, round: true)] %Panoramix.Query{ aggregations: [ %{name: :event_count, type: &quot;count&quot;}, %{ fieldName: :user_unique, name: :unique_ids, round: true, type: &quot;HLLSketchMerge&quot; } ], ... }","ref":"Panoramix.Query.html#from/2","title":"Panoramix.Query.from/2","type":"macro"},{"doc":"","ref":"Panoramix.Query.html#to_json/1","title":"Panoramix.Query.to_json/1","type":"function"},{"doc":"","ref":"Panoramix.Query.html#t:t/0","title":"Panoramix.Query.t/0","type":"type"},{"doc":"","ref":"Panoramix.Error.html","title":"Panoramix.Error","type":"exception"},{"doc":"","ref":"Panoramix.Error.html#t:t/0","title":"Panoramix.Error.t/0","type":"type"},{"doc":"PanoramixAn open-source client library for sending requests to Apache Druid from applications written in Elixir. The project uses HTTPoison as an HTTP client for sending queries.","ref":"readme.html","title":"Panoramix","type":"extras"},{"doc":"Add Panoramix as a dependency to your project.defp deps do [ {:panoramix, &quot;&gt;= 0.12.0 and &lt; 1.0.0&quot;} ] end","ref":"readme.html#getting-started","title":"Panoramix - Getting Started","type":"extras"},{"doc":"Panoramix requires a Druid Broker profile to be defined in the configuration of your application.config :panoramix, request_timeout: 120_000, query_priority: 0, broker_profiles: [ default: [ base_url: &quot;https://druid-broker-host:9088&quot;, cacertfile: &quot;path/to/druid-certificate.crt&quot;, http_username: &quot;username&quot;, http_password: &quot;password&quot; ] ]request_timeout: Query timeout in millis to be used in Context of all Druid queries. query_priority: Priority to be used in Context of all Druid queries.","ref":"readme.html#configuration","title":"Panoramix - Configuration","type":"extras"},{"doc":"Build a query like this:use Panoramix q = from &quot;my_datasource&quot;, query_type: &quot;timeseries&quot;, intervals: [&quot;2019-03-01T00:00:00+00:00/2019-03-04T00:00:00+00:00&quot;], granularity: :day, filter: dimensions.foo == &quot;bar&quot;, aggregations: [event_count: count(), unique_id_count: hyperUnique(:user_unique)] And then send it:Panoramix.post_query(q, :default)Where :default is a configuration profile pointing to your Druid server.The default value for the profile argument is :default, so if you only need a single configuration you can omit it:Panoramix.post_query(q)Response example:{:ok, [ %{ &quot;result&quot; =&gt; %{ &quot;event_count&quot; =&gt; 7544, &quot;unique_id_count&quot; =&gt; 43.18210933535 }, &quot;timestamp&quot; =&gt; &quot;2019-03-01T00:00:00.000Z&quot; }, %{ &quot;result&quot; =&gt; %{ &quot;event_count&quot; =&gt; 1051, &quot;unique_id_count&quot; =&gt; 104.02052398847 }, &quot;timestamp&quot; =&gt; &quot;2019-03-02T00:00:00.000Z&quot; }, %{ &quot;result&quot; =&gt; %{ &quot;event_count&quot; =&gt; 4591, &quot;unique_id_count&quot; =&gt; 79.19885795313 }, &quot;timestamp&quot; =&gt; &quot;2019-03-03T00:00:00.000Z&quot; } ]}","ref":"readme.html#usage","title":"Panoramix - Usage","type":"extras"},{"doc":"You can check correctness of your configuration by requesting status from Druid Broker. A successfull response will look like this.iex(1)&gt; Panoramix.status(:default) {:ok, %{ &quot;memory&quot; =&gt; %{...}, &quot;modules&quot; =&gt; [...], &quot;version&quot; =&gt; &quot;0.13.0&quot; }}","ref":"readme.html#troubleshooting","title":"Panoramix - Troubleshooting","type":"extras"},{"doc":"We'd love to accept your contributions in a form of patches, bug reports and new features! Before opening a pull request please make sure your changes pass all the tests.","ref":"readme.html#contributions","title":"Panoramix - Contributions","type":"extras"},{"doc":"Except as otherwise noted this software is licensed under the Apache License, Version 2.0Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License athttp://www.apache.org/licenses/LICENSE-2.0Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.The code was Copyright 2018-2019 Game Analytics Limited and/or its affiliates.","ref":"readme.html#license","title":"Panoramix - License","type":"extras"}]